// --------------------------------------------------------------------
// FileDialogɂAt@C擾NX
//  Windows̃o[WɂAς̂ŁA
//  Win9xnɍ킹BAAWin9xnlȂ΁A
//  `defineQ폜ΗǂB
// --------------------------------------------------------------------

//#define _WIN32_WINNT 0x400
//#define WINVER 0x400

#include <windows>
#include "filedlg.h"

void shortFilename(char *org,char *dst,int mxlen)
{
	int orl,i,j,dsl,dsp ;
	if(mxlen<19) mxlen=19 ;
	orl=strlen(org) ;
	if(orl<=mxlen) strcpy(dst,org) ;
	else{
	  dsl=orl-mxlen ;
	  strcpy(dst,&org[dsl]) ;
	  j=0 ;
	  if(org[1]==':' && org[2]=='\\'){
	    for(i=0 ; i<3 ; i++) dst[j++]=org[i] ;
	  }
	  for(i=0 ; i<3 ; i++) dst[j++]='.' ;
	}
}

void pureFilename(char *pathname,char *fname)
{
	int i,l,p ;
	if(0==(l=strlen(pathname))) fname[0]='\0' ;
	else{
	  for(i=l ; i>0 ; i--){
	    if(pathname[i]=='\\'){ p=i+1 ; break ; }
	  }
	  strcpy(fname,&pathname[p]) ;
	}
}

void splitFname(char *purename,char *name,char *ext)
{
	int i,l,p ;
	if(0==(l=strlen(purename))) name[0]=ext[0]='\0' ;
	else{
	  p=0 ;
	  for(i=l ; i>0 ; i--){
	    if(purename[i]=='.'){ p=i+1 ; break ; }
	  }
	  strcpy(name,purename) ;
	  if(p!=0){
	    strcpy(ext,&purename[p]) ;
	    name[p-1]='\0' ;
	  }
	}
}

// --------------------------------------------------------------------
// --------------------------------------------------------------------

void FFSET::Check(void)
{
	int i,l ;
	if(Filter[0]=='\0' || CName[0]=='\0'){
	  CName[0]=Filter[0]=DefExt[0]='\0' ;
	  return ;
	}
	l=strlen(Filter) ;
	for(i=0 ; i<l ; i++){
	  if(Filter[i]=='|') Filter[i]='\0' ;
	}
	if(Filter[l-1]!='\0') Filter[l+1]='\0' ;
}

// --------------------------------------------------------------------
// --------------------------------------------------------------------

void FileDlg::Init(HWND ownerHwnd)
{
	owner=ownerHwnd ;
	Filename[0]='\0' ;
	DefExt[0]=DefDir[0]=DefFname[0]='\0' ;
	
#if (_WIN32_WINNT >= 0x0500)
	memset(&ofn,0,sizeof(OPENFILENAME)) ;
	ofn.lStructSize     =  OPENFILENAME_SIZE_VERSION_400 ;
#else
	memset(&ofn,0,sizeof(OPENFILENAME)) ;
	ofn.lStructSize     = sizeof(OPENFILENAME) ;
#endif
	FsPreset[0]=new FFSET() ;
	FsPresetNumb=1 ;
}

FileDlg::~FileDlg()
{
	int i ;
	for(i=0 ; i<FsPresetNumb ; i++){
	  delete FsPreset[i] ;
	}
}

void FileDlg::setup(char *title,LPCTSTR ffilter,int save)
{
	Filename[0]='\0' ;
	FileTitle[0]='\0' ;
	if(DefFname[0]!='\0') strcpy(Filename,DefFname) ;
	DefFname[0]='\0' ; // ftHǵAPł܂B
#if (_WIN32_WINNT >= 0x0500)
	memset(&ofn,0,sizeof(OPENFILENAME)) ;
	ofn.lStructSize     =  OPENFILENAME_SIZE_VERSION_400 ;
#else
	memset(&ofn,0,sizeof(OPENFILENAME)) ;
	ofn.lStructSize     = sizeof(OPENFILENAME) ;
#endif
	ofn.hwndOwner       = owner ;
	ofn.hInstance       = 0 ;
	ofn.lpstrFilter     = ffilter ;
	ofn.nFilterIndex    = 1 ;
	ofn.lpstrFile       = (LPSTR)Filename ;
	ofn.nMaxFile        = 256 ;
	ofn.lpstrTitle      = title ;
	ofn.lpstrFileTitle  = FileTitle ;
	ofn.nMaxFileTitle   = 64 ;
	if(DefDir[0]!='\0')
	  ofn.lpstrInitialDir = DefDir ; 
	if(DefExt[0]!='\0')
	  ofn.lpstrDefExt     = DefExt ;
	ofn.lpstrTitle        = title ;
	ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST ;
	if(save) ofn.Flags=OFN_HIDEREADONLY ;
}

BOOL FileDlg::OpenDlg(char *title,LPCTSTR ffilter)
{
	BOOL Res ;
	setup(title,ffilter) ;
	try{ Res=GetOpenFileName(&ofn) ; }
	catch(...){ Res=FALSE ; }
	if(!Res){
	  Filename[0]='\0' ;
	  return(FALSE) ;
	}
	else return(TRUE) ;
}

BOOL FileDlg::SaveDlg(char *title,LPCTSTR ffilter)
{
	BOOL Res ;
	setup(title,ffilter,1) ;
	try{ Res=GetSaveFileName(&ofn) ; }
	catch(...){ Res=FALSE ; }
	if(!Res){
	  Filename[0]='\0' ;
	  return(FALSE) ;
	}
	else return(TRUE) ;
}

BOOL FileDlg::OpenDlg(char *title,LPCTSTR ffilter,char *GetFname)
{
	BOOL Rv ;
	Rv=OpenDlg(title,ffilter) ;
	strcpy(GetFname,Filename) ;
	return(Rv) ;
}

BOOL FileDlg::SaveDlg(char *title,LPCTSTR ffilter,char *GetFname)
{
	BOOL Rv ;
	Rv=SaveDlg(title,ffilter) ;
	strcpy(GetFname,Filename) ;
	return(Rv) ;
}

char *FileDlg::GetShortname(int maxlen)
{
	if(Filename[0]=='\0') return(Filename) ;
	shortFilename(Filename,SFilename,maxlen) ;
	return(SFilename) ;
}

void FileDlg::GetShortname(char *getbf,int maxlen)
{
	if(Filename[0]=='\0') getbf[0]='\0' ;
	else shortFilename(Filename,getbf,maxlen) ;
}

void FileDlg::UseDefaultFname(char *deffile)
{
	strncpy(DefFname,deffile,63) ;
}

BOOL FileDlg::Preset(char *FFID,char *ffilter,char *defext)
{
	if(FsPresetNumb>=32) return(FALSE) ;
	FsPreset[FsPresetNumb]=new FFSET(FFID,ffilter,defext) ;
	if(FsPreset[FsPresetNumb]->IsYourID(FFID)) FsPresetNumb++ ;
	else{
	  delete FsPreset[FsPresetNumb] ;
	  return(FALSE) ;
	}
	return(TRUE) ;
}

BOOL FileDlg::Select(char *title,char *getfn,char *FFID,BOOL fd_Open_or_Save)
{
	char tempFnGetBuffer[256] ;
	int i,Fsp ;
	BOOL Res ;
	Fsp=0 ;
	for(i=0 ; i<FsPresetNumb ; i++){
	  if(FsPreset[i]->IsYourID(FFID)){ Fsp=i ; break ; }
	}
	tempFnGetBuffer[0]='\0' ;
	// ȂƁAFsp==0ƂȂāADefaultgB
	if(fd_Open_or_Save){ // OPEN̏ꍇ
	  Res=OpenDlg(title,FsPreset[Fsp]->FFilter(),
	                    FsPreset[Fsp]->DefaultExt(),tempFnGetBuffer) ;
	}
	else{
	  Res=SaveDlg(title,FsPreset[Fsp]->FFilter(),
	                    FsPreset[Fsp]->DefaultExt(),tempFnGetBuffer) ;
	}
	if(!Res) return(FALSE) ;
	if(tempFnGetBuffer[0]=='\0') return(FALSE) ;
	strcpy(getfn,tempFnGetBuffer) ;
	return(TRUE) ;
}
